function _extends() { return _extends = Object.assign ? Object.assign.bind() : function (n) { for (var e = 1; e < arguments.length; e++) { var t = arguments[e]; for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]); } return n; }, _extends.apply(null, arguments); }
import React, { memo, useMemo } from "react";
import Flex from "../../templates/flex";
import Select from "../../select";
import { TextSmall } from "../../typography";
var HeaderGroupBy = function HeaderGroupBy(_ref) {
  var grouping = _ref.grouping,
    groupByColumns = _ref.groupByColumns,
    onGroupBy = _ref.onGroupBy,
    tableMeta = _ref.tableMeta,
    dataGa = _ref.dataGa,
    dataColumns = _ref.dataColumns;
  var groupByOptions = useMemo(function () {
    return groupByColumns ? _extends({
      "default": {
        label: "None",
        value: ""
      }
    }, Object.keys(groupByColumns).reduce(function (acc, colId) {
      var _extends2;
      var column = dataColumns.find(function (_ref2) {
        var id = _ref2.id;
        return id === colId;
      });
      return _extends({}, acc, (_extends2 = {}, _extends2[colId] = {
        label: groupByColumns[colId].name || (column == null ? void 0 : column.name) || column.id,
        value: colId
      }, _extends2));
    }, {})) : null;
  }, [groupByColumns]);
  if (!groupByOptions) return;
  return /*#__PURE__*/React.createElement(Flex, _extends({
    alignItems: "center",
    "data-testid": "tableGroupBy",
    gap: 1
  }, tableMeta.groupByContainerStyles), /*#__PURE__*/React.createElement(TextSmall, {
    "data-testid": "tableGroupByLabel",
    color: "textLite",
    whiteSpace: "nowrap"
  }, "Group by"), /*#__PURE__*/React.createElement(Select, {
    "data-ga": dataGa + "::group-by-filter::table-filter",
    "data-testid": "tableGroupByFilter",
    menuPortalTarget: document.body,
    onChange: function onChange(_ref3) {
      var value = _ref3.value;
      return onGroupBy(value);
    },
    options: Object.values(groupByOptions),
    styles: {
      size: "tiny",
      minWidth: 120
    },
    value: groupByOptions[grouping] || groupByOptions["default"]
  }));
};
export default /*#__PURE__*/memo(HeaderGroupBy);